/***************************************************************************
****  Treiber fr 600dpi Laser	 (HP-kompatibel)												****
***************************************************************************/

/* Sollte auch Deskjet und o. . 300dpi Laser bedienen */

/* evt. mu der Rand (LINKS) angepat werden, also:
 * Dazu als Faustregel: 1Byte = 8Pixel = (8/600)" = (1/75)" ~ 0.339mm 
 * Das heit: Grafik jetzt ca. 4mm zu weit links, Rand um 12 erhhen, 
 * denn 12*0.338666 = 4.064mm
 * (Diese Formel gilt natrlich nur bei 600 DPI.)
 * Fr den oberen Rand gilt 1mm ~ 23.5 Zeilen. da (25.4/600)mm = 1 Zeile
 * (Wenn man diese Datei an einen anderen Drucker anpat, dann diese 
 *  bitte entsprechend umbennen (z.B. HP_LASER.C, dann wre z.B. 
 *  HOEHE=3350, LINKS=??? und an mich senden, BITTE!)
 */

#define OBEN 0L		/* Oberer Rand (unbekannt) */
#define LINKS 0L	/* Linker Rand (unbekannt) */
#define MAX_DPI 600L	/* Maximale Auflsung 600dpi */
#define BREITE 5000L	/* max. Breite einer Grafikseite */
#define HOEHE 7000L	/* max. Hoehe */

#include "hp.c"	/* HP-Standarttreiber */
